################################################################################
##  A simple interface widget as base of all interface parts.                 ##  
##  LAST EDIT: Thu Aug  4 10:41:14 1994 by ekki(@prakinf.tu-ilmenau.de)
################################################################################
##  This file belongs to the YART implementation. Copying, distribution and   ##
##  legal info is in the file COPYRGHT which should be distributed with this  ##
##  file. If COPYRGHT is not available or for more info please contact:       ##
##                                                                            ##  
##		yart@prakinf.tu-ilmenau.de                                    ##
##                                                                            ##  
## (C) Copyright 1994 YART team                                               ##
################################################################################

IOM_InterfaceDevice ?

Tcl_Object IOM_InterfaceWidget IOM_InterfaceDevice {tkPath frTop frCenter frBottom} {Name} {String} \
{Creates a new widget called {ARG 1 Name} with some frame widgets inside the top frame.} \
{
    frame .$Name
    pack .$Name -fill both -expand 1
    frame    .$Name.interfaceWidget
    pack append .$Name .$Name.interfaceWidget {fill expand}
    set $THIS->tkPath .$Name.interfaceWidget

    # create following widget structure:

    ##########################
    #         frTOP          #
    ##########################
    #        frCenter        #
    ##########################
    #        frBOTTOM        #
    ##########################

    set $THIS->frTop    [nullframe [set $THIS->tkPath].top top fillx]
    set $THIS->frCenter [nullframe [set $THIS->tkPath].frCenter top]
    set $THIS->frBottom [nullframe [set $THIS->tkPath].bottom top fillx]
}

Tcl_Method IOM_InterfaceWidget ~IOM_InterfaceWidget {} {} {The destructor of InterfaceWidget} {
    destroy .$THIS
}

IOM_InterfaceWidget -description {The abstract interface class for interface objects, who are now toplevel windows  (for example the tree class). }

IOM_InterfaceWidget -keywords {IOM User-Interface}

