################################################################################
##  Dialog box for Surface attribute.                                         ##  
##  LAST EDIT: Thu Aug  4 10:59:42 1994 by ekki(@prakinf.tu-ilmenau.de)
################################################################################
##  This file belongs to the YART implementation. Copying, distribution and   ##
##  legal info is in the file COPYRGHT which should be distributed with this  ##
##  file. If COPYRGHT is not available or for more info please contact:       ##
##                                                                            ##  
##		yart@prakinf.tu-ilmenau.de                                    ##
##                                                                            ##  
## (C) Copyright 1994 YART team                                               ##
################################################################################

IOM_TopBox ?

Tcl_Object IOM_SurfaceBox IOM_TopBox {updateCommands} {Name} {String} \
	{Creates a new Surface editor box called {ARG 1 Name}.} \
	{
    $THIS -buildCurrentObjectLabel
    wm title [set $THIS->tkTop] "IOM.surface"
    
    set path [set $THIS->frCenter]
    
    append $THIS->updateCommands [rgb_scale $path.f0 Ambient      \
	    "$THIS -callObject -get_ambient" "$THIS -callObject -ambient" 12]
    append $THIS->updateCommands [rgb_scale $path.f1 Diffuse      \
	    "$THIS -callObject -get_diffuse" "$THIS -callObject -diffuse" 12]
    append $THIS->updateCommands [rgb_scale $path.f2 Specular     \
	    "$THIS -callObject -get_specular" "$THIS -callObject -specular" 12]
    append $THIS->updateCommands [rgb_scale $path.f3 Emission     \
	    "$THIS -callObject -get_emission" "$THIS -callObject -emission" 12]
    
    #    append $THIS->updateCommands [s_scale $path.f4 Transmission   \
	    "$THIS -callObject -get_transmission" "$THIS -callObject -transmission" 12]

    #    append $THIS->updateCommands [s_scale $path.f5 Shininess      \
	    "$THIS -callObject -get_shininess" "$THIS -callObject -shininess" 12]

    #    append $THIS->updateCommands [s_scale $path.f6 Refraction     \
	    "$THIS -callObject -get_refraction" "$THIS -callObject -refraction" 12]

    set path [set $THIS->frBottom]
    button $path.attrClear -text "Clear Surface" -command  \
	    "$THIS -callObject -attrClear Surface;\
	    $THIS -update; $THIS -callCBs;"
    button $path.update -text "Update" -command  \
	    "$THIS -update; $THIS -callCBs;"
    button $path.quit -text "Close" -command  "delete $THIS"
    pack append $path \
	    $path.update {fill expand left} \
	    $path.attrClear {fill expand left} \
	    $path.quit {fill expand left}
}

Tcl_Method IOM_SurfaceBox -update {} {} {Update the data representation of the widgets.} {
    eval [set $THIS->updateCommands]
}

IOM_SurfaceBox -description {The Userinterface to the surface attribut.}

IOM_SurfaceBox -keywords {IOM Userinterface}



