//  LAST EDIT: Mon Feb 14 01:15:23 1994 by ekki(@prakinf.tu-ilmenau.de)
#ifndef _InterpStream_h_
#define _InterpStream_h_

/*
 * StrUtil.h - iostream for tcl interpreters
 *
 * -----------------------------------------------------------------------------
 * Copyright 1993 Allan Brighton.
 * 
 * Permission to use, copy, modify, and distribute this software and its
 * documentation for any purpose and without fee is hereby granted,
 * provided that the above copyright notice appear in all copies.  Allan
 * Brighton make no representations about the suitability of this software
 * for any purpose.  It is provided "as is" without express or implied
 * warranty.
 * -----------------------------------------------------------------------------
 */


#include <iostream.h>
#include <strstream.h>
extern  "C" {
#include <tk.h>
}


class InterpStream : public ostrstream {
private:
    Tcl_Interp* interp_;	// current tcl interpreter
    int status_;

public:
    InterpStream(Tcl_Interp* interp) : interp_(interp), status_(0) {}
    InterpStream& eval();
    InterpStream& result();
    operator void*() const { return (void*)!status_; }
    int operator !() const { return status_; }
};


static struct Eval_ { } eval;
static struct Result_ { } result;
InterpStream& operator<<(ostream& os, Eval_);
InterpStream& operator<<(ostream& os, Result_);

#endif 
